import os

from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget
from axipy import Style

from StyleTools.controls.compositeStyle.ui.StyleComposite.helper_wigets import PaintStyleWidget


#from AxyPy.Style.StyleComposite.helper_wigets import PaintStyleWidget


class styleWidget(QWidget):
    def __init__(self,title,style:Style,parent=None):
        super(styleWidget, self).__init__(parent)
        self.ui=self.load_ui("widgetStyle.ui",parent)
        self.ui.groupBox.setTitle(title)
        self.ui.pb_run.clicked.connect(self.__run)

        self.__style=style
        self.__prepareStyle()
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    def show(self):
        self.ui.show()
        jkl=0
    def __temp(self):
        jkl=0
    def __prepareStyle(self):
        type_style=PaintStyleWidget.getTypeStyle(self.__style)
        self.__paint_style_widget=PaintStyleWidget.factoryStyleWidget(type_style,self.__style,self.ui)
        self.__change_style(self.__style.to_mapinfo())
        self.__paint_style_widget.channged_style.connect(self.__change_style)
        self.ui.layout_style.addWidget(self.__paint_style_widget)
    def __run(self):
        mi_style_text=self.ui.pl_text_style.toPlainText()
        style=Style.from_mapinfo(mi_style_text)
        self.__paint_style_widget.updateStyle(style)
    def __change_style(self,new_style):
        self.ui.pl_text_style.setPlainText(new_style)


